# =================================================================================================
#<profile4xi profile = "12" />
#<program4xi program = "buffer4xi.py">
#<abstract4xi abstract = "Buffer Management"/>
#<refer4xi reference = "Buffers"/>
#<verify4xi verification = "10" target = "buffer4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Buffer4Xi',  
            'create2buffer4xi',
            'create2subbuffer4xi',
            'get2bufferinfo4xi',
            'release2buffer4xi',
            'retain2buffer4xi',
            'set2buffer4xi'
          ]
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi

# -------------------------------------------------------------------------------------------------
# Buffer modules                           
# -------------------------------------------------------------------------------------------------
from apu2buffer4xi import APU2Buffer4Xi                                                                 
from bpu2buffer4xi import BPU2Buffer4Xi
from cpu2buffer4xi import CPU2Buffer4Xi
from dpu2buffer4xi import DPU2Buffer4Xi
from epu2buffer4xi import EPU2Buffer4Xi
from fpu2buffer4xi import FPU2Buffer4Xi
from gpu2buffer4xi import GPU2Buffer4Xi
from hpu2buffer4xi import HPU2Buffer4Xi
from ipu2buffer4xi import IPU2Buffer4Xi
from jpu2buffer4xi import JPU2Buffer4Xi
from kpu2buffer4xi import KPU2Buffer4Xi
from lpu2buffer4xi import LPU2Buffer4Xi
from mpu2buffer4xi import MPU2Buffer4Xi
from npu2buffer4xi import NPU2Buffer4Xi
from opu2buffer4xi import OPU2Buffer4Xi
from ppu2buffer4xi import PPU2Buffer4Xi
from qpu2buffer4xi import QPU2Buffer4Xi
from rpu2buffer4xi import RPU2Buffer4Xi
from spu2buffer4xi import SPU2Buffer4Xi
from tpu2buffer4xi import TPU2Buffer4Xi
from upu2buffer4xi import UPU2Buffer4Xi
from vpu2buffer4xi import VPU2Buffer4Xi
from xpu2buffer4xi import XPU2Buffer4Xi
from wpu2buffer4xi import WPU2Buffer4Xi
from ypu2buffer4xi import YPU2Buffer4Xi
from zpu2buffer4xi import ZPU2Buffer4Xi


from apu2buffer4xi import create2buffer4apu
from bpu2buffer4xi import create2buffer4bpu
from cpu2buffer4xi import create2buffer4cpu
from dpu2buffer4xi import create2buffer4dpu
from epu2buffer4xi import create2buffer4epu
from fpu2buffer4xi import create2buffer4fpu
from gpu2buffer4xi import create2buffer4gpu
from hpu2buffer4xi import create2buffer4hpu
from ipu2buffer4xi import create2buffer4ipu
from jpu2buffer4xi import create2buffer4jpu
from kpu2buffer4xi import create2buffer4kpu
from lpu2buffer4xi import create2buffer4lpu
from mpu2buffer4xi import create2buffer4mpu
from npu2buffer4xi import create2buffer4npu
from opu2buffer4xi import create2buffer4opu
from ppu2buffer4xi import create2buffer4ppu
from qpu2buffer4xi import create2buffer4qpu
from rpu2buffer4xi import create2buffer4rpu
from spu2buffer4xi import create2buffer4spu
from tpu2buffer4xi import create2buffer4tpu
from upu2buffer4xi import create2buffer4upu
from vpu2buffer4xi import create2buffer4vpu
from xpu2buffer4xi import create2buffer4xpu
from wpu2buffer4xi import create2buffer4wpu
from ypu2buffer4xi import create2buffer4ypu
from zpu2buffer4xi import create2buffer4zpu


from apu2buffer4xi import create2subbuffer4apu 
from bpu2buffer4xi import create2subbuffer4bpu 
from cpu2buffer4xi import create2subbuffer4cpu 
from dpu2buffer4xi import create2subbuffer4dpu 
from epu2buffer4xi import create2subbuffer4epu 
from fpu2buffer4xi import create2subbuffer4fpu 
from gpu2buffer4xi import create2subbuffer4gpu 
from hpu2buffer4xi import create2subbuffer4hpu 
from ipu2buffer4xi import create2subbuffer4ipu 
from jpu2buffer4xi import create2subbuffer4jpu 
from kpu2buffer4xi import create2subbuffer4kpu 
from lpu2buffer4xi import create2subbuffer4lpu 
from mpu2buffer4xi import create2subbuffer4mpu 
from npu2buffer4xi import create2subbuffer4npu 
from opu2buffer4xi import create2subbuffer4opu 
from ppu2buffer4xi import create2subbuffer4ppu 
from qpu2buffer4xi import create2subbuffer4qpu 
from rpu2buffer4xi import create2subbuffer4rpu 
from spu2buffer4xi import create2subbuffer4spu 
from tpu2buffer4xi import create2subbuffer4tpu 
from upu2buffer4xi import create2subbuffer4upu 
from vpu2buffer4xi import create2subbuffer4vpu 
from xpu2buffer4xi import create2subbuffer4xpu 
from wpu2buffer4xi import create2subbuffer4wpu 
from ypu2buffer4xi import create2subbuffer4ypu 
from zpu2buffer4xi import create2subbuffer4zpu 

from apu2buffer4xi import get2bufferinfo4apu
from bpu2buffer4xi import get2bufferinfo4bpu
from cpu2buffer4xi import get2bufferinfo4cpu
from dpu2buffer4xi import get2bufferinfo4dpu
from epu2buffer4xi import get2bufferinfo4epu
from fpu2buffer4xi import get2bufferinfo4fpu
from gpu2buffer4xi import get2bufferinfo4gpu
from hpu2buffer4xi import get2bufferinfo4hpu
from ipu2buffer4xi import get2bufferinfo4ipu
from jpu2buffer4xi import get2bufferinfo4jpu
from kpu2buffer4xi import get2bufferinfo4kpu
from lpu2buffer4xi import get2bufferinfo4lpu
from mpu2buffer4xi import get2bufferinfo4mpu
from npu2buffer4xi import get2bufferinfo4npu
from opu2buffer4xi import get2bufferinfo4opu
from ppu2buffer4xi import get2bufferinfo4ppu
from qpu2buffer4xi import get2bufferinfo4qpu
from rpu2buffer4xi import get2bufferinfo4rpu
from spu2buffer4xi import get2bufferinfo4spu
from tpu2buffer4xi import get2bufferinfo4tpu
from upu2buffer4xi import get2bufferinfo4upu
from vpu2buffer4xi import get2bufferinfo4vpu
from xpu2buffer4xi import get2bufferinfo4xpu
from wpu2buffer4xi import get2bufferinfo4wpu
from ypu2buffer4xi import get2bufferinfo4ypu
from zpu2buffer4xi import get2bufferinfo4zpu


from apu2buffer4xi import release2buffer4apu
from bpu2buffer4xi import release2buffer4bpu
from cpu2buffer4xi import release2buffer4cpu
from dpu2buffer4xi import release2buffer4dpu
from epu2buffer4xi import release2buffer4epu
from fpu2buffer4xi import release2buffer4fpu
from gpu2buffer4xi import release2buffer4gpu
from hpu2buffer4xi import release2buffer4hpu
from ipu2buffer4xi import release2buffer4ipu
from jpu2buffer4xi import release2buffer4jpu
from kpu2buffer4xi import release2buffer4kpu
from lpu2buffer4xi import release2buffer4lpu
from mpu2buffer4xi import release2buffer4mpu
from npu2buffer4xi import release2buffer4npu
from opu2buffer4xi import release2buffer4opu
from ppu2buffer4xi import release2buffer4ppu
from qpu2buffer4xi import release2buffer4qpu
from rpu2buffer4xi import release2buffer4rpu
from spu2buffer4xi import release2buffer4spu
from tpu2buffer4xi import release2buffer4tpu
from upu2buffer4xi import release2buffer4upu
from vpu2buffer4xi import release2buffer4vpu
from xpu2buffer4xi import release2buffer4xpu
from wpu2buffer4xi import release2buffer4wpu
from ypu2buffer4xi import release2buffer4ypu
from zpu2buffer4xi import release2buffer4zpu

from apu2buffer4xi import retain2buffer4apu
from bpu2buffer4xi import retain2buffer4bpu
from cpu2buffer4xi import retain2buffer4cpu
from dpu2buffer4xi import retain2buffer4dpu
from epu2buffer4xi import retain2buffer4epu
from fpu2buffer4xi import retain2buffer4fpu
from gpu2buffer4xi import retain2buffer4gpu
from hpu2buffer4xi import retain2buffer4hpu
from ipu2buffer4xi import retain2buffer4ipu
from jpu2buffer4xi import retain2buffer4jpu
from kpu2buffer4xi import retain2buffer4kpu
from lpu2buffer4xi import retain2buffer4lpu
from mpu2buffer4xi import retain2buffer4mpu
from npu2buffer4xi import retain2buffer4npu
from opu2buffer4xi import retain2buffer4opu
from ppu2buffer4xi import retain2buffer4ppu
from qpu2buffer4xi import retain2buffer4qpu
from rpu2buffer4xi import retain2buffer4rpu
from spu2buffer4xi import retain2buffer4spu
from tpu2buffer4xi import retain2buffer4tpu
from upu2buffer4xi import retain2buffer4upu
from vpu2buffer4xi import retain2buffer4vpu
from xpu2buffer4xi import retain2buffer4xpu
from wpu2buffer4xi import retain2buffer4wpu
from ypu2buffer4xi import retain2buffer4ypu
from zpu2buffer4xi import retain2buffer4zpu


from apu2buffer4xi import set2buffer4apu
from bpu2buffer4xi import set2buffer4bpu
from cpu2buffer4xi import set2buffer4cpu
from dpu2buffer4xi import set2buffer4dpu
from epu2buffer4xi import set2buffer4epu
from fpu2buffer4xi import set2buffer4fpu
from gpu2buffer4xi import set2buffer4gpu
from hpu2buffer4xi import set2buffer4hpu
from ipu2buffer4xi import set2buffer4ipu
from jpu2buffer4xi import set2buffer4jpu
from kpu2buffer4xi import set2buffer4kpu
from lpu2buffer4xi import set2buffer4lpu
from mpu2buffer4xi import set2buffer4mpu
from npu2buffer4xi import set2buffer4npu
from opu2buffer4xi import set2buffer4opu
from ppu2buffer4xi import set2buffer4ppu
from qpu2buffer4xi import set2buffer4qpu
from rpu2buffer4xi import set2buffer4rpu
from spu2buffer4xi import set2buffer4spu
from tpu2buffer4xi import set2buffer4tpu
from upu2buffer4xi import set2buffer4upu
from vpu2buffer4xi import set2buffer4vpu
from xpu2buffer4xi import set2buffer4xpu
from wpu2buffer4xi import set2buffer4wpu
from ypu2buffer4xi import set2buffer4ypu
from zpu2buffer4xi import set2buffer4zpu



# -------------------------------------------------------------------------------------------------
# Context modules                           
# -------------------------------------------------------------------------------------------------
from apu2context4xi import APU2Context4Xi                                                                           
from bpu2context4xi import BPU2Context4Xi
from cpu2context4xi import CPU2Context4Xi
from dpu2context4xi import DPU2Context4Xi
from epu2context4xi import EPU2Context4Xi
from fpu2context4xi import FPU2Context4Xi
from gpu2context4xi import GPU2Context4Xi
from hpu2context4xi import HPU2Context4Xi
from ipu2context4xi import IPU2Context4Xi
from jpu2context4xi import JPU2Context4Xi
from kpu2context4xi import KPU2Context4Xi
from lpu2context4xi import LPU2Context4Xi
from mpu2context4xi import MPU2Context4Xi
from npu2context4xi import NPU2Context4Xi
from opu2context4xi import OPU2Context4Xi
from ppu2context4xi import PPU2Context4Xi
from qpu2context4xi import QPU2Context4Xi
from rpu2context4xi import RPU2Context4Xi
from spu2context4xi import SPU2Context4Xi
from tpu2context4xi import TPU2Context4Xi
from upu2context4xi import UPU2Context4Xi
from vpu2context4xi import VPU2Context4Xi
from xpu2context4xi import XPU2Context4Xi
from wpu2context4xi import WPU2Context4Xi
from ypu2context4xi import YPU2Context4Xi
from zpu2context4xi import ZPU2Context4Xi

from apu2context4xi import create2context4apu 
from bpu2context4xi import create2context4bpu 
from cpu2context4xi import create2context4cpu 
from dpu2context4xi import create2context4dpu 
from epu2context4xi import create2context4epu 
from fpu2context4xi import create2context4fpu 
from gpu2context4xi import create2context4gpu 
from hpu2context4xi import create2context4hpu 
from ipu2context4xi import create2context4ipu 
from jpu2context4xi import create2context4jpu 
from kpu2context4xi import create2context4kpu 
from lpu2context4xi import create2context4lpu 
from mpu2context4xi import create2context4mpu 
from npu2context4xi import create2context4npu 
from opu2context4xi import create2context4opu 
from ppu2context4xi import create2context4ppu 
from qpu2context4xi import create2context4qpu 
from rpu2context4xi import create2context4rpu 
from spu2context4xi import create2context4spu 
from tpu2context4xi import create2context4tpu 
from upu2context4xi import create2context4upu 
from vpu2context4xi import create2context4vpu 
from xpu2context4xi import create2context4xpu 
from wpu2context4xi import create2context4wpu 
from ypu2context4xi import create2context4ypu 
from zpu2context4xi import create2context4zpu 


from apu2context4xi import get2context4apu
from bpu2context4xi import get2context4bpu
from cpu2context4xi import get2context4cpu
from dpu2context4xi import get2context4dpu
from epu2context4xi import get2context4epu
from fpu2context4xi import get2context4fpu
from gpu2context4xi import get2context4gpu
from hpu2context4xi import get2context4hpu
from ipu2context4xi import get2context4ipu
from jpu2context4xi import get2context4jpu
from kpu2context4xi import get2context4kpu
from lpu2context4xi import get2context4lpu
from mpu2context4xi import get2context4mpu
from npu2context4xi import get2context4npu
from opu2context4xi import get2context4opu
from ppu2context4xi import get2context4ppu
from qpu2context4xi import get2context4qpu
from rpu2context4xi import get2context4rpu
from spu2context4xi import get2context4spu
from tpu2context4xi import get2context4tpu
from upu2context4xi import get2context4upu
from vpu2context4xi import get2context4vpu
from xpu2context4xi import get2context4xpu
from wpu2context4xi import get2context4wpu
from ypu2context4xi import get2context4ypu
from zpu2context4xi import get2context4zpu

from apu2context4xi import release2context4apu
from bpu2context4xi import release2context4bpu
from cpu2context4xi import release2context4cpu
from dpu2context4xi import release2context4dpu
from epu2context4xi import release2context4epu
from fpu2context4xi import release2context4fpu
from gpu2context4xi import release2context4gpu
from hpu2context4xi import release2context4hpu
from ipu2context4xi import release2context4ipu
from jpu2context4xi import release2context4jpu
from kpu2context4xi import release2context4kpu
from lpu2context4xi import release2context4lpu
from mpu2context4xi import release2context4mpu
from npu2context4xi import release2context4npu
from opu2context4xi import release2context4opu
from ppu2context4xi import release2context4ppu
from qpu2context4xi import release2context4qpu
from rpu2context4xi import release2context4rpu
from spu2context4xi import release2context4spu
from tpu2context4xi import release2context4tpu
from upu2context4xi import release2context4upu
from vpu2context4xi import release2context4vpu
from xpu2context4xi import release2context4xpu
from wpu2context4xi import release2context4wpu
from ypu2context4xi import release2context4ypu
from zpu2context4xi import release2context4zpu

from apu2context4xi import retain2context4apu
from bpu2context4xi import retain2context4bpu
from cpu2context4xi import retain2context4cpu
from dpu2context4xi import retain2context4dpu
from epu2context4xi import retain2context4epu
from fpu2context4xi import retain2context4fpu
from gpu2context4xi import retain2context4gpu
from hpu2context4xi import retain2context4hpu
from ipu2context4xi import retain2context4ipu
from jpu2context4xi import retain2context4jpu
from kpu2context4xi import retain2context4kpu
from lpu2context4xi import retain2context4lpu
from mpu2context4xi import retain2context4mpu
from npu2context4xi import retain2context4npu
from opu2context4xi import retain2context4opu
from ppu2context4xi import retain2context4ppu
from qpu2context4xi import retain2context4qpu
from rpu2context4xi import retain2context4rpu
from spu2context4xi import retain2context4spu
from tpu2context4xi import retain2context4tpu
from upu2context4xi import retain2context4upu
from vpu2context4xi import retain2context4vpu
from xpu2context4xi import retain2context4xpu
from wpu2context4xi import retain2context4wpu
from ypu2context4xi import retain2context4ypu
from zpu2context4xi import retain2context4zpu

from apu2context4xi import set2context4apu
from bpu2context4xi import set2context4bpu
from cpu2context4xi import set2context4cpu
from dpu2context4xi import set2context4dpu
from epu2context4xi import set2context4epu
from fpu2context4xi import set2context4fpu
from gpu2context4xi import set2context4gpu
from hpu2context4xi import set2context4hpu
from ipu2context4xi import set2context4ipu
from jpu2context4xi import set2context4jpu
from kpu2context4xi import set2context4kpu
from lpu2context4xi import set2context4lpu
from mpu2context4xi import set2context4mpu
from npu2context4xi import set2context4npu
from opu2context4xi import set2context4opu
from ppu2context4xi import set2context4ppu
from qpu2context4xi import set2context4qpu
from rpu2context4xi import set2context4rpu
from spu2context4xi import set2context4spu
from tpu2context4xi import set2context4tpu
from upu2context4xi import set2context4upu
from vpu2context4xi import set2context4vpu
from xpu2context4xi import set2context4xpu
from wpu2context4xi import set2context4wpu
from ypu2context4xi import set2context4ypu
from zpu2context4xi import set2context4zpu



# -------------------------------------------------------------------------------------------------
# Device modules                           
# -------------------------------------------------------------------------------------------------
from apu2device4xi import APU4Xi                                                                                   
from bpu2device4xi import BPU4Xi
from cpu2device4xi import CPU4Xi
from dpu2device4xi import DPU4Xi
from epu2device4xi import EPU4Xi
from fpu2device4xi import FPU4Xi
from gpu2device4xi import GPU4Xi
from hpu2device4xi import HPU4Xi
from ipu2device4xi import IPU4Xi
from jpu2device4xi import JPU4Xi
from kpu2device4xi import KPU4Xi
from lpu2device4xi import LPU4Xi
from mpu2device4xi import MPU4Xi
from npu2device4xi import NPU4Xi
from opu2device4xi import OPU4Xi
from ppu2device4xi import PPU4Xi
from qpu2device4xi import QPU4Xi
from rpu2device4xi import RPU4Xi
from spu2device4xi import SPU4Xi
from tpu2device4xi import TPU4Xi
from upu2device4xi import UPU4Xi
from vpu2device4xi import VPU4Xi
from xpu2device4xi import XPU4Xi
from wpu2device4xi import WPU4Xi
from ypu2device4xi import YPU4Xi
from zpu2device4xi import ZPU4Xi

from apu2device4xi import init2apu4xi 
from bpu2device4xi import init2bpu4xi 
from cpu2device4xi import init2cpu4xi 
from dpu2device4xi import init2dpu4xi 
from epu2device4xi import init2epu4xi 
from fpu2device4xi import init2fpu4xi 
from gpu2device4xi import init2gpu4xi 
from hpu2device4xi import init2hpu4xi 
from ipu2device4xi import init2ipu4xi 
from jpu2device4xi import init2jpu4xi 
from kpu2device4xi import init2kpu4xi 
from lpu2device4xi import init2lpu4xi 
from mpu2device4xi import init2mpu4xi 
from npu2device4xi import init2npu4xi 
from opu2device4xi import init2opu4xi 
from ppu2device4xi import init2ppu4xi 
from qpu2device4xi import init2qpu4xi 
from rpu2device4xi import init2rpu4xi 
from spu2device4xi import init2spu4xi 
from tpu2device4xi import init2tpu4xi 
from upu2device4xi import init2upu4xi 
from vpu2device4xi import init2vpu4xi 
from xpu2device4xi import init2xpu4xi 
from wpu2device4xi import init2wpu4xi 
from ypu2device4xi import init2ypu4xi 
from zpu2device4xi import init2zpu4xi 

from apu2device4xi import set2apu4xi
from bpu2device4xi import set2bpu4xi
from cpu2device4xi import set2cpu4xi
from dpu2device4xi import set2dpu4xi
from epu2device4xi import set2epu4xi
from fpu2device4xi import set2fpu4xi
from gpu2device4xi import set2gpu4xi
from hpu2device4xi import set2hpu4xi
from ipu2device4xi import set2ipu4xi
from jpu2device4xi import set2jpu4xi
from kpu2device4xi import set2kpu4xi
from lpu2device4xi import set2lpu4xi
from mpu2device4xi import set2mpu4xi
from npu2device4xi import set2npu4xi
from opu2device4xi import set2opu4xi
from ppu2device4xi import set2ppu4xi
from qpu2device4xi import set2qpu4xi
from rpu2device4xi import set2rpu4xi
from spu2device4xi import set2spu4xi
from tpu2device4xi import set2tpu4xi
from upu2device4xi import set2upu4xi
from vpu2device4xi import set2vpu4xi
from xpu2device4xi import set2xpu4xi
from wpu2device4xi import set2wpu4xi
from ypu2device4xi import set2ypu4xi
from zpu2device4xi import set2zpu4xi

from apu2device4xi import get2apu4xi
from bpu2device4xi import get2bpu4xi
from cpu2device4xi import get2cpu4xi
from dpu2device4xi import get2dpu4xi
from epu2device4xi import get2epu4xi
from fpu2device4xi import get2fpu4xi
from gpu2device4xi import get2gpu4xi
from hpu2device4xi import get2hpu4xi
from ipu2device4xi import get2ipu4xi
from jpu2device4xi import get2jpu4xi
from kpu2device4xi import get2kpu4xi
from lpu2device4xi import get2lpu4xi
from mpu2device4xi import get2mpu4xi
from npu2device4xi import get2npu4xi
from opu2device4xi import get2opu4xi
from ppu2device4xi import get2ppu4xi
from qpu2device4xi import get2qpu4xi
from rpu2device4xi import get2rpu4xi
from spu2device4xi import get2spu4xi
from tpu2device4xi import get2tpu4xi
from upu2device4xi import get2upu4xi
from vpu2device4xi import get2vpu4xi
from xpu2device4xi import get2xpu4xi
from wpu2device4xi import get2wpu4xi
from ypu2device4xi import get2ypu4xi
from zpu2device4xi import get2zpu4xi



# -------------------------------------------------------------------------------------------------
# Platform                           
# -------------------------------------------------------------------------------------------------
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from queue4xi import Queue4Xi 
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global buffer4xi
global subbuffer4xi       
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

#"
#"/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2buffer4xi" usage = " 
#
# print('=' *33)          
# print('(Step 2A/33) OF BUFFER5TEST - TRYING TO CREATE BUFFER ', time4xi())   
# print('=' *33)        
# try:
#     cc2xi = create2buffer4xi()                                                                            # NO PARAMETERS - THE SYSTEM CREATES   
#     print('(Step 2B/33) OF BUFFER5TEST - CREATED BUFFER: ', cc2xi)                                  
#     # 
# except:
#     print('(Step 2Z/33) OF BUFFER5TEST *** FAILED TO CREATE BUFFER', time4xi()) 
#
#">
# -------------------------------------------------------------------------------------------------   
def create2buffer4xi(task4create2buffer=None):

    '''
    initializes buffer4xi
    '''
    global buffer4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2buffer4xi"
    method2print = "create2buffer4xi"

    message2print = "{(Step 1A/33) started" + "; create2buffer4xi-started: " + str(create2buffer4xi)  + "; time: " + time4xi() + "}"   
    print4xi(class2print, method2print, message2print)
    # <function create2buffer4xi at 0x0000000003A582C8> 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4create2buffer-to-create2buffer4xi: " + str(task4create2buffer) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # None

 
    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4create2buffer is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - BUFFER NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if buffer4xi is None:                                                                                       
                buffer4xi = {} 
                code2ack  = code2ack + '1D-'
        except:
            buffer4xi = {} 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4create2buffer-try-by-create2buffer4xi: " + str(task4create2buffer)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
 

    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES - EACH WITH THE CONTEXT OR THEIR OWN (GIVEN BY THE CALLED ONE) 
            # ----------------------------------------------------------------------------------------- 
        
            buffer4xi = {} 
            buffer4xi['APU'] = create2buffer4apu()                                                                        
            buffer4xi['BPU'] = create2buffer4bpu()   
            buffer4xi['CPU'] = create2buffer4cpu()   
            buffer4xi['DPU'] = create2buffer4dpu()   
            buffer4xi['EPU'] = create2buffer4epu()   
            buffer4xi['FPU'] = create2buffer4fpu()   
            buffer4xi['GPU'] = create2buffer4gpu()   
            buffer4xi['HPU'] = create2buffer4hpu()   
            buffer4xi['IPU'] = create2buffer4ipu()   
            buffer4xi['JPU'] = create2buffer4jpu()   
            buffer4xi['KPU'] = create2buffer4kpu()   
            buffer4xi['LPU'] = create2buffer4lpu()   
            buffer4xi['MPU'] = create2buffer4mpu()   
            buffer4xi['NPU'] = create2buffer4npu()   
            buffer4xi['OPU'] = create2buffer4opu()   
            buffer4xi['PPU'] = create2buffer4ppu()   
            buffer4xi['QPU'] = create2buffer4qpu()   
            buffer4xi['RPU'] = create2buffer4rpu()   
            buffer4xi['SPU'] = create2buffer4spu()   
            buffer4xi['TPU'] = create2buffer4tpu()   
            buffer4xi['UPU'] = create2buffer4upu()   
            buffer4xi['VPU'] = create2buffer4vpu()   
            buffer4xi['XPU'] = create2buffer4xpu()   
            buffer4xi['WPU'] = create2buffer4wpu()   
            buffer4xi['YPU'] = create2buffer4ypu()   
            buffer4xi['ZPU'] = create2buffer4zpu()   
                                                                                                                                                                                                                                                                                                            
                                         
            message2print = "{(Step 3A/33) initialized" + "; buffer4xi-initialized-by-create2buffer4xi to: " + str(buffer4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; buffer4xi-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    

        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['APU'] = create2buffer4apu(task4create2buffer['APU'])
            
            message2print = "{(Step A/33) initialized" + "; apu-initialized-by-create2buffer4xi to: " + str(buffer4xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'POINTER2BUFFER': <mmap.mmap object at 0x0000000004902138>,
            #  'ACK2RETURN': ' 13B-15B-16B-17B-',
            #  'NACK2RETURN': ' 11Z1-12Z1-14Z1-18Z1-19Z1-',
            #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4apu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4apu', 'METHOD': 'create2context4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000032CAB48>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'FLAGS': 0, 'SIZE': 33792}; time: 01:27:58 09/02/11 Pacific Daylight Time}

            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['BPU'] = create2buffer4bpu(task4create2buffer['BPU'])
            
            message2print = "{(Step B/33) initialized" + "; bpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'POINTER2BUFFER': <mmap.mmap object at 0x0000000004902240>,
            #  'ACK2RETURN': ' 13B-15B-16B-17B-',
            #  'NACK2RETURN': ' 11Z1-12Z1-14Z1-18Z1-19Z1-',
            #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4bpu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4bpu', 'METHOD': 'create2context4bpu'}, 'FUNCTION2CALLBACK': <function trace2context4bpu at 0x0000000003F4FBC8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'FLAGS': 0, 'SIZE': 33792}; time: 01:27:58 09/02/11 Pacific Daylight Time}

            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['CPU'] = create2buffer4cpu(task4create2buffer['CPU'])
            
            message2print = "{(Step C/33) initialized" + "; cpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'POINTER2BUFFER': <mmap.mmap object at 0x0000000004902348>,
            #  'ACK2RETURN': ' 13B-15B-16B-17B-',
            #  'NACK2RETURN': ' 11Z1-12Z1-14Z1-18Z1-19Z1-',
            #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4cpu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4cpu', 'METHOD': 'create2context4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x0000000003E53C48>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'FLAGS': 0, 'SIZE': 33792}; time: 01:27:58 09/02/11 Pacific Daylight Time}

            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['DPU'] = create2buffer4dpu(task4create2buffer['DPU'])
            
            message2print = "{(Step D/33) initialized" + "; dpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'POINTER2BUFFER': <mmap.mmap object at 0x0000000004902450>,
            #  'ACK2RETURN': ' 13B-15B-16B-17B-',
            #  'NACK2RETURN': ' 11Z1-12Z1-14Z1-18Z1-19Z1-',
            #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003CA5CC8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'FLAGS': 0, 'SIZE': 33792}; time: 01:27:58 09/02/11 Pacific Daylight Time}

            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['EPU'] = create2buffer4epu(task4create2buffer['EPU'])
            
            message2print = "{(Step E/33) initialized" + "; epu-initialized-by-create2buffer4xi to: " + str(buffer4xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'POINTER2BUFFER': <mmap.mmap object at 0x0000000004902558>, 'ACK2RETURN': ' 13B-15B-16B-17B-', 'NACK2RETURN': ' 11Z1-12Z1-14Z1-18Z1-19Z1-', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4epu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4epu', 'METHOD': 'create2context4epu'}, 'FUNCTION2CALLBACK': <function trace2context4epu at 0x0000000003D33D48>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'FLAGS': 0, 'SIZE': 33792}; time: 01:27:58 09/02/11 Pacific Daylight Time}

            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['FPU'] = create2buffer4fpu(task4create2buffer['FPU'])
            
            message2print = "{(Step F/33) initialized" + "; fpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['GPU'] = create2buffer4gpu(task4create2buffer['GPU'])
            
            message2print = "{(Step G/33) initialized" + "; gpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['HPU'] = create2buffer4hpu(task4create2buffer['HPU'])
            
            message2print = "{(Step H/33) initialized" + "; hpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['IPU'] = create2buffer4ipu(task4create2buffer['IPU'])
            
            message2print = "{(Step I/33) initialized" + "; ipu-initialized-by-create2buffer4xi to: " + str(buffer4xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['JPU'] = create2buffer4jpu(task4create2buffer['JPU'])
            
            message2print = "{(Step J/33) initialized" + "; jpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['KPU'] = create2buffer4kpu(task4create2buffer['KPU'])
            
            message2print = "{(Step K/33) initialized" + "; kpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['LPU'] = create2buffer4lpu(task4create2buffer['LPU'])
            
            message2print = "{(Step L/33) initialized" + "; lpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['MPU'] = create2buffer4mpu(task4create2buffer['MPU'])
            
            message2print = "{(Step M/33) initialized" + "; mpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['NPU'] = create2buffer4npu(task4create2buffer['NPU'])
            
            message2print = "{(Step N/33) initialized" + "; npu-initialized-by-create2buffer4xi to: " + str(buffer4xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['OPU'] = create2buffer4opu(task4create2buffer['OPU'])
            
            message2print = "{(Step O/33) initialized" + "; opu-initialized-by-create2buffer4xi to: " + str(buffer4xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['PPU'] = create2buffer4ppu(task4create2buffer['PPU'])
            
            message2print = "{(Step P/33) initialized" + "; ppu-initialized-by-create2buffer4xi to: " + str(buffer4xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['QPU'] = create2buffer4qpu(task4create2buffer['QPU'])
            
            message2print = "{(Step Q/33) initialized" + "; qpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['RPU'] = create2buffer4rpu(task4create2buffer['RPU'])
            
            message2print = "{(Step R/33) initialized" + "; rpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['SPU'] = create2buffer4spu(task4create2buffer['SPU'])
            
            message2print = "{(Step S/33) initialized" + "; spu-initialized-by-create2buffer4xi to: " + str(buffer4xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['TPU'] = create2buffer4tpu(task4create2buffer['TPU'])
            
            message2print = "{(Step T/33) initialized" + "; tpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['UPU'] = create2buffer4upu(task4create2buffer['UPU'])
            
            message2print = "{(Step U/33) initialized" + "; upu-initialized-by-create2buffer4xi to: " + str(buffer4xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['VPU'] = create2buffer4vpu(task4create2buffer['VPU'])
            
            message2print = "{(Step V/33) initialized" + "; vpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['WPU'] = create2buffer4wpu(task4create2buffer['WPU'])
            
            message2print = "{(Step W/33) initialized" + "; wpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['XPU'] = create2buffer4xpu(task4create2buffer['XPU'])
            
            message2print = "{(Step X/33) initialized" + "; xpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['YPU'] = create2buffer4ypu(task4create2buffer['YPU'])
            
            message2print = "{(Step Y/33) initialized" + "; ypu-initialized-by-create2buffer4xi to: " + str(buffer4xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            buffer4xi['ZPU'] = create2buffer4zpu(task4create2buffer['ZPU'])
            
            message2print = "{(Step Z/33) initialized" + "; zpu-initialized-by-create2buffer4xi to: " + str(buffer4xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'POINTER2BUFFER': <mmap.mmap object at 0x0000000005376B30>, 'ACK2RETURN': ' 13B-15B-16B-17B-', 'NACK2RETURN': ' 11Z1-12Z1-14Z1-18Z1-19Z1-', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4zpu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4zpu', 'METHOD': 'create2context4zpu'}, 'FUNCTION2CALLBACK': <function trace2context4zpu at 0x00000000042A3848>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'FLAGS': 0, 'SIZE': 33792}; time: 01:27:58 09/02/11 Pacific Daylight Time}

            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    
    message2print = "{(Step 33/33) returning" + "; buffer4xi-returning-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # {'DPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4dpu-failed ; time: 01:27:57 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4dpu', 'METHOD': 'create2buffer4dpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4dpu at 0x0000000003D29448>, 'POINTER2BUFFER': <mmap.mmap object at 0x000000000434B920>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 01:27:57 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003CA5CC8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}, 
    #  'EPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4epu-failed ; time: 01:27:57 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4epu', 'METHOD': 'create2buffer4epu'}, 'FUNCTION2CALLBACK': <function trace2buffer4epu at 0x0000000003D754C8>, 'POINTER2BUFFER': <mmap.mmap object at 0x000000000434B978>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4epu-failed ; time: 01:27:57 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4epu', 'METHOD': 'create2context4epu'}, 'FUNCTION2CALLBACK': <function trace2context4epu at 0x0000000003D33D48>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_EPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}, 
    #  'BPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4bpu-failed ; time: 01:27:57 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4bpu', 'METHOD': 'create2buffer4bpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4bpu at 0x0000000003E49348>, 'POINTER2BUFFER': <mmap.mmap object at 0x000000000434B818>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4bpu-failed ; time: 01:27:57 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4bpu', 'METHOD': 'create2context4bpu'}, 'FUNCTION2CALLBACK': <function trace2context4bpu at 0x0000000003F4FBC8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_BPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}, 
    #  'CPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4cpu-failed ; time: 01:27:57 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4cpu', 'METHOD': 'create2buffer4cpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4cpu at 0x0000000003C9B3C8>, 'POINTER2BUFFER': <mmap.mmap object at 0x000000000434B8C8>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4cpu-failed ; time: 01:27:57 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4cpu', 'METHOD': 'create2context4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x0000000003E53C48>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4017, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_CPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}, 
    #  'VPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4vpu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4vpu', 'METHOD': 'create2buffer4vpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4vpu at 0x0000000004183D48>, 'POINTER2BUFFER': <mmap.mmap object at 0x000000000434BF50>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4vpu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4vpu', 'METHOD': 'create2context4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x0000000004173648>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4005, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_VPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}, 
    #  'RPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4rpu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4rpu', 'METHOD': 'create2buffer4rpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4rpu at 0x0000000003FF2B48>, 'POINTER2BUFFER': <mmap.mmap object at 0x000000000434BD98>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4rpu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4rpu', 'METHOD': 'create2context4rpu'}, 'FUNCTION2CALLBACK': <function trace2context4rpu at 0x0000000003FE4448>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4022, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_RPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}, 
    #  'WPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4wpu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4wpu', 'METHOD': 'create2buffer4wpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4wpu at 0x0000000004238E48>, 'POINTER2BUFFER': <mmap.mmap object at 0x000000000434BAD8>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4wpu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4wpu', 'METHOD': 'create2context4wpu'}, 'FUNCTION2CALLBACK': <function trace2context4wpu at 0x0000000004223748>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_WPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}, 
    #  'SPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4spu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4spu', 'METHOD': 'create2buffer4spu'}, 'FUNCTION2CALLBACK': <function trace2buffer4spu at 0x0000000004084BC8>, 'POINTER2BUFFER': <mmap.mmap object at 0x000000000434BE48>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4spu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4spu', 'METHOD': 'create2context4spu'}, 'FUNCTION2CALLBACK': <function trace2context4spu at 0x00000000040734C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_glo
    # 

    return buffer4xi
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2subbuffer4xi" usage = " 
#
# print('=' *33)          
# print('(Step 2A/33) OF BUFFER5TEST - TRYING TO CREATE SUB-BUFFER ', time4xi())   
# print('=' *33)        
# try:
#     cc2xi = create2subbuffer4xi()                                                                            # NO PARAMETERS - THE SYSTEM CREATES   
#     print('(Step 2B/33) OF BUFFER5TEST - CREATED SUB-BUFFER: ', cc2xi)                                  
#     # 
# except:
#     print('(Step 2Z/33) OF BUFFER5TEST *** FAILED TO CREATE SUB-BUFFER', time4xi()) 
#
#">

# -------------------------------------------------------------------------------------------------   
def create2subbuffer4xi(task4create2subbuffer=None):

    '''
    initializes subsubbuffer4xi
    '''
    global subbuffer4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2subbuffer4xi"
    method2print = "create2subbuffer4xi"

    message2print = "{(Step 1A/33) started" + "; create2subbuffer4xi-started: " + str(create2subbuffer4xi)  + "; time: " + time4xi() + "}"   
    print4xi(class2print, method2print, message2print)
    # <function create2subbuffer4xi at 0x00000000039F0948>
  
             
    message2print = "{(Step 1B/33) passed" + "; task4create2subbuffer-to-create2subbuffer4xi: " + str(task4create2subbuffer) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 


    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4create2subbuffer is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - BUFFER NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if subbuffer4xi is None:                                                                                       
                subbuffer4xi = {} 
                code2ack  = code2ack + '1D-'
        except:
            subbuffer4xi = {} 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4create2subbuffer-try-by-create2subbuffer4xi: " + str(task4create2subbuffer)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # 

    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES - EACH WITH THE CONTEXT OR THEIR OWN (GIVEN BY THE CALLED ONE) 
            # ----------------------------------------------------------------------------------------- 
        
            subbuffer4xi = {} 
            subbuffer4xi['APU'] = create2subbuffer4apu()                                                                        
            subbuffer4xi['BPU'] = create2subbuffer4bpu()       
            subbuffer4xi['CPU'] = create2subbuffer4cpu()       
            subbuffer4xi['DPU'] = create2subbuffer4dpu()       
            subbuffer4xi['EPU'] = create2subbuffer4epu()       
            subbuffer4xi['FPU'] = create2subbuffer4fpu()       
            subbuffer4xi['GPU'] = create2subbuffer4gpu()       
            subbuffer4xi['HPU'] = create2subbuffer4hpu()       
            subbuffer4xi['IPU'] = create2subbuffer4ipu()       
            subbuffer4xi['JPU'] = create2subbuffer4jpu()       
            subbuffer4xi['KPU'] = create2subbuffer4kpu()       
            subbuffer4xi['LPU'] = create2subbuffer4lpu()       
            subbuffer4xi['MPU'] = create2subbuffer4mpu()       
            subbuffer4xi['NPU'] = create2subbuffer4npu()       
            subbuffer4xi['OPU'] = create2subbuffer4opu()       
            subbuffer4xi['PPU'] = create2subbuffer4ppu()       
            subbuffer4xi['QPU'] = create2subbuffer4qpu()       
            subbuffer4xi['RPU'] = create2subbuffer4rpu()       
            subbuffer4xi['SPU'] = create2subbuffer4spu()       
            subbuffer4xi['TPU'] = create2subbuffer4tpu()       
            subbuffer4xi['UPU'] = create2subbuffer4upu()       
            subbuffer4xi['VPU'] = create2subbuffer4vpu()       
            subbuffer4xi['XPU'] = create2subbuffer4xpu()       
            subbuffer4xi['WPU'] = create2subbuffer4wpu()       
            subbuffer4xi['YPU'] = create2subbuffer4ypu()       
            subbuffer4xi['ZPU'] = create2subbuffer4zpu()       
                                                                                                                                                                                                                                                                                                            
                                         
            message2print = "{(Step 3A/33) initialized" + "; subbuffer4xi-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; subbuffer4xi-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    

        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['APU'] = create2subbuffer4apu(task4create2subbuffer['APU'])
            
            message2print = "{(Step A/33) initialized" + "; apu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ-'          

        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['BPU'] = create2subbuffer4bpu(task4create2subbuffer['BPU'])
            
            message2print = "{(Step B/33) initialized" + "; bpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['CPU'] = create2subbuffer4cpu(task4create2subbuffer['CPU'])
            
            message2print = "{(Step C/33) initialized" + "; cpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['DPU'] = create2subbuffer4dpu(task4create2subbuffer['DPU'])
            
            message2print = "{(Step D/33) initialized" + "; dpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['EPU'] = create2subbuffer4epu(task4create2subbuffer['EPU'])
            
            message2print = "{(Step E/33) initialized" + "; epu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['FPU'] = create2subbuffer4fpu(task4create2subbuffer['FPU'])
            
            message2print = "{(Step F/33) initialized" + "; fpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['GPU'] = create2subbuffer4gpu(task4create2subbuffer['GPU'])
            
            message2print = "{(Step G/33) initialized" + "; gpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['HPU'] = create2subbuffer4hpu(task4create2subbuffer['HPU'])
            
            message2print = "{(Step H/33) initialized" + "; hpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['IPU'] = create2subbuffer4ipu(task4create2subbuffer['IPU'])
            
            message2print = "{(Step I/33) initialized" + "; ipu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['JPU'] = create2subbuffer4jpu(task4create2subbuffer['JPU'])
            
            message2print = "{(Step J/33) initialized" + "; jpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ-'     
           
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['KPU'] = create2subbuffer4kpu(task4create2subbuffer['KPU'])
            
            message2print = "{(Step K/33) initialized" + "; kpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['LPU'] = create2subbuffer4lpu(task4create2subbuffer['LPU'])
            
            message2print = "{(Step L/33) initialized" + "; lpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['MPU'] = create2subbuffer4mpu(task4create2subbuffer['MPU'])
            
            message2print = "{(Step M/33) initialized" + "; mpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['NPU'] = create2subbuffer4npu(task4create2subbuffer['NPU'])
            
            message2print = "{(Step N/33) initialized" + "; npu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['OPU'] = create2subbuffer4opu(task4create2subbuffer['OPU'])
            
            message2print = "{(Step O/33) initialized" + "; opu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['PPU'] = create2subbuffer4ppu(task4create2subbuffer['PPU'])
            
            message2print = "{(Step P/33) initialized" + "; ppu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['QPU'] = create2subbuffer4qpu(task4create2subbuffer['QPU'])
            
            message2print = "{(Step Q/33) initialized" + "; qpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['RPU'] = create2subbuffer4rpu(task4create2subbuffer['RPU'])
            
            message2print = "{(Step R/33) initialized" + "; rpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['SPU'] = create2subbuffer4spu(task4create2subbuffer['SPU'])
            
            message2print = "{(Step S/33) initialized" + "; spu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['TPU'] = create2subbuffer4tpu(task4create2subbuffer['TPU'])
            
            message2print = "{(Step T/33) initialized" + "; tpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['UPU'] = create2subbuffer4upu(task4create2subbuffer['UPU'])
            
            message2print = "{(Step U/33) initialized" + "; upu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['VPU'] = create2subbuffer4vpu(task4create2subbuffer['VPU'])
            
            message2print = "{(Step V/33) initialized" + "; vpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ-'     
           
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['WPU'] = create2subbuffer4wpu(task4create2subbuffer['WPU'])
            
            message2print = "{(Step W/33) initialized" + "; wpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['XPU'] = create2subbuffer4xpu(task4create2subbuffer['XPU'])
            
            message2print = "{(Step X/33) initialized" + "; xpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['YPU'] = create2subbuffer4ypu(task4create2subbuffer['YPU'])
            
            message2print = "{(Step Y/33) initialized" + "; ypu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ-'     
            
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            subbuffer4xi['ZPU'] = create2subbuffer4zpu(task4create2subbuffer['ZPU'])
            
            message2print = "{(Step Z/33) initialized" + "; zpu-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    
    message2print = "{(Step 33/33) returning" + "; subbuffer4xi-returning-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              


    return subbuffer4xi
             
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2buffer4xi" usage = "
#
# Example 1:
#     print('(Step 4A/33) OF BUFFER5TEST - TRYING TO SET BUFFER4XI ', time4xi())
#     try:                               
#         response4set2buffer = set2buffer4xi()                                                       
#         print('(Step 4B/33) OF BUFFER5TEST - RESPONSE4SET2CONTEXT : ', response4set2buffer) 
#     except:
#         print('(Step 4Z1/33) OF BUFFER5TEST *** FAILED TO SET BUFFER4XI ', time4xi())                  
#                            
#">

# -------------------------------------------------------------------------------------------------   
def set2buffer4xi(task4set2buffer=None):

    '''
    sets buffer4xi
    '''
    global buffer4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2buffer4xi"
    method2print = "set2buffer4xi"

    message2print = "{(Step 1A/33) started" + "; set2buffer4xi-started: " + str(set2buffer4xi)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
             
    message2print = "{(Step 1B/33) passed" + "; task4set2buffer-to-set2buffer4xi: " + str(task4set2buffer) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
    
 
    code2ack  = ' '
    code2nack = ' '

    if buffer4xi is None:
        buffer4xi = create2buffer4xi()                                                                            # CREATE BUFFER
                                
        message2print = "{(Step 1C/33) set" + "; buffer4xi-set-by-set2buffer4xi to: " + str(buffer4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
        

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step A/33) passing" + "; task-passing-to-set2buffer4apu: " + str(task4set2buffer['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['APU'] = set2buffer4apu(task4set2buffer['APU'])                                                      # 
         
        message2print = "{(Step A1/33) set" + "; apu-context-set-by-set2buffer4apu to: " + str(buffer4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'A1-'
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-set2buffer4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step B/33) passing" + "; task-passing-to-set2buffer4bpu: " + str(task4set2buffer['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['BPU'] = set2buffer4bpu(task4set2buffer['BPU'])                                                      # 
         
        message2print = "{(Step B1/33) set" + "; bpu-context-set-by-set2buffer4bpu to: " + str(buffer4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'B1-'
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set2buffer4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step C/33) passing" + "; task-passing-to-set2buffer4cpu: " + str(task4set2buffer['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['CPU'] = set2buffer4cpu(task4set2buffer['CPU'])                                                      # 
         
        message2print = "{(Step C1/33) set" + "; cpu-context-set-by-set2buffer4cpu to: " + str(buffer4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'C1-'
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set2buffer4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step D/33) passing" + "; task-passing-to-set2buffer4dpu: " + str(task4set2buffer['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['DPU'] = set2buffer4dpu(task4set2buffer['DPU'])                                                      # 
         
        message2print = "{(Step D1/33) set" + "; dpu-context-set-by-set2buffer4dpu to: " + str(buffer4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'D1-'
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set2buffer4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step E/33) passing" + "; task-passing-to-set2buffer4epu: " + str(task4set2buffer['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['EPU'] = set2buffer4epu(task4set2buffer['EPU'])                                                      # 
         
        message2print = "{(Step E1/33) set" + "; epu-context-set-by-set2buffer4epu to: " + str(buffer4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'E1-'
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set2buffer4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step F/33) passing" + "; task-passing-to-set2buffer4fpu: " + str(task4set2buffer['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['FPU'] = set2buffer4fpu(task4set2buffer['FPU'])                                                      # 
         
        message2print = "{(Step F1/33) set" + "; fpu-context-set-by-set2buffer4fpu to: " + str(buffer4xi ['PU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'F1-'
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set2buffer4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step G/33) passing" + "; task-passing-to-set2buffer4gpu: " + str(task4set2buffer['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['GPU'] = set2buffer4gpu(task4set2buffer['GPU'])                                                      # 
         
        message2print = "{(Step G1/33) set" + "; gpu-context-set-by-set2buffer4gpu to: " + str(buffer4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'G1-'
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set2buffer4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step H/33) passing" + "; task-passing-to-set2buffer4hpu: " + str(task4set2buffer['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['HPU'] = set2buffer4hpu(task4set2buffer['HPU'])                                                      # 
         
        message2print = "{(Step H1/33) set" + "; hpu-context-set-by-set2buffer4hpu to: " + str(buffer4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'H1-'
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set2buffer4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step I/33) passing" + "; task-passing-to-set2buffer4ipu: " + str(task4set2buffer['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['IPU'] = set2buffer4ipu(task4set2buffer['IPU'])                                                      # 
         
        message2print = "{(Step I1/33) set" + "; ipu-context-set-by-set2buffer4ipu to: " + str(buffer4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'I1-'
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set2buffer4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step J/33) passing" + "; task-passing-to-set2buffer4jpu: " + str(task4set2buffer['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['JPU'] = set2buffer4jpu(task4set2buffer['JPU'])                                                      # 
         
        message2print = "{(Step J1/33) set" + "; jpu-context-set-by-set2buffer4jpu to: " + str(buffer4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'J1-'
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set2buffer4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step K/33) passing" + "; task-passing-to-set2buffer4kpu: " + str(task4set2buffer['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['KPU'] = set2buffer4kpu(task4set2buffer['KPU'])                                                      # 
         
        message2print = "{(Step K1/33) set" + "; kpu-context-set-by-set2buffer4kpu to: " + str(buffer4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'K1-'
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set2buffer4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step L/33) passing" + "; task-passing-to-set2buffer4lpu: " + str(task4set2buffer['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['LPU'] = set2buffer4lpu(task4set2buffer['LPU'])                                                      # 
         
        message2print = "{(Step L1/33) set" + "; lpu-context-set-by-set2buffer4lpu to: " + str(buffer4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + '1-'
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set2buffer4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step M/33) passing" + "; task-passing-to-set2buffer4mpu: " + str(task4set2buffer['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['MPU'] = set2buffer4mpu(task4set2buffer['MPU'])                                                      # 
         
        message2print = "{(Step M1/33) set" + "; mpu-context-set-by-set2buffer4mpu to: " + str(buffer4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'M1-'
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set2buffer4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step N/33) passing" + "; task-passing-to-set2buffer4npu: " + str(task4set2buffer['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['NPU'] = set2buffer4npu(task4set2buffer['NPU'])                                                      # 
         
        message2print = "{(Step N1/33) set" + "; npu-context-set-by-set2buffer4npu to: " + str(buffer4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'N1-'
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set2buffer4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step O/33) passing" + "; task-passing-to-set2buffer4opu: " + str(task4set2buffer['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['OPU'] = set2buffer4opu(task4set2buffer['OPU'])                                                      # 
         
        message2print = "{(Step O1/33) set" + "; opu-context-set-by-set2buffer4opu to: " + str(buffer4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'O1-'
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set2buffer4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step P/33) passing" + "; task-passing-to-set2buffer4ppu: " + str(task4set2buffer['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['PPU'] = set2buffer4ppu(task4set2buffer['PPU'])                                                      # 
         
        message2print = "{(Step P1/33) set" + "; ppu-context-set-by-set2buffer4ppu to: " + str(buffer4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'P1-'
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set2buffer4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Q/33) passing" + "; task-passing-to-set2buffer4qpu: " + str(task4set2buffer['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['QPU'] = set2buffer4qpu(task4set2buffer['QPU'])                                                      # 
         
        message2print = "{(Step Q1/33) set" + "; qpu-context-set-by-set2buffer4qpu to: " + str(buffer4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Q1-'
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set2buffer4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step R/33) passing" + "; task-passing-to-set2buffer4rpu: " + str(task4set2buffer['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['RPU'] = set2buffer4rpu(task4set2buffer['RPU'])                                                      # 
         
        message2print = "{(Step R1/33) set" + "; rpu-context-set-by-set2buffer4rpu to: " + str(buffer4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'R1-'
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set2buffer4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step S/33) passing" + "; task-passing-to-set2buffer4spu: " + str(task4set2buffer['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['SPU'] = set2buffer4spu(task4set2buffer['SPU'])                                                      # 
         
        message2print = "{(Step S1/33) set" + "; spu-context-set-by-set2buffer4spu to: " + str(buffer4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'S1-'
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set2buffer4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step T/33) passing" + "; task-passing-to-set2buffer4tpu: " + str(task4set2buffer['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['TPU'] = set2buffer4tpu(task4set2buffer['TPU'])                                                      # 
         
        message2print = "{(Step T1/33) set" + "; tpu-context-set-by-set2buffer4tpu to: " + str(buffer4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'T1-'
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set2buffer4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step U/33) passing" + "; task-passing-to-set2buffer4upu: " + str(task4set2buffer['UPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['UPU'] = set2buffer4upu(task4set2buffer['UPU'])                                                      # 
         
        message2print = "{(Step U1/33) set" + "; upu-context-set-by-set2buffer4upu to: " + str(buffer4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'U1-'
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set2buffer4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step V/33) passing" + "; task-passing-to-set2buffer4vpu: " + str(task4set2buffer['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['VPU'] = set2buffer4vpu(task4set2buffer['VPU'])                                                      # 
         
        message2print = "{(Step V1/33) set" + "; vpu-context-set-by-set2buffer4vpu to: " + str(buffer4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'V1-'
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set2buffer4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step W/33) passing" + "; task-passing-to-set2buffer4wpu: " + str(task4set2buffer['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['WPU'] = set2buffer4wpu(task4set2buffer['WPU'])                                                      # 
         
        message2print = "{(Step W1/33) set" + "; wpu-context-set-by-set2buffer4wpu to: " + str(buffer4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'W1-'
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set2buffer4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step X/33) passing" + "; task-passing-to-set2buffer4xpu: " + str(task4set2buffer['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['XPU'] = set2buffer4xpu(task4set2buffer['XPU'])                                                      # 
         
        message2print = "{(Step X1/33) set" + "; xpu-context-set-by-set2buffer4xpu to: " + str(buffer4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'X1-'
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set2buffer4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Y/33) passing" + "; task-passing-to-set2buffer4ypu: " + str(task4set2buffer['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['YPU'] = set2buffer4ypu(task4set2buffer['YPU'])                                                      # 
         
        message2print = "{(Step Y1/33) set" + "; ypu-context-set-by-set2buffer4ypu to: " + str(buffer4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Y1-'
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set2buffer4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Z/33) passing" + "; task-passing-to-set2buffer4zpu: " + str(task4set2buffer['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['ZPU'] = set2buffer4zpu(task4set2buffer['ZPU'])                                                      # 
         
        message2print = "{(Step Z1/33) set" + "; zpu-context-set-by-set2buffer4zpu to: " + str(buffer4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Z1-'
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set2buffer4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------

    
    message2print = "{(Step 33/33) returning" + "; buffer4xi-returning-by-set2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    
    return buffer4xi

            
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2buffer4xi" usage = "
#
# Example 1:
#     print('(Step 4A/33) OF BUFFER5TEST - TRYING TO RETAIN BUFFER4XI ', time4xi())
#     try:                               
#         response4retain2buffer = retain2buffer4xi()                                                       
#         print('(Step 4B/33) OF BUFFER5TEST - RESPONSE4SET2CONTEXT : ', response4retain2buffer) 
#     except:
#         print('(Step 4Z1/33) OF BUFFER5TEST *** FAILED TO RETAIN BUFFER4XI ', time4xi())                  
#                            
#">

# -------------------------------------------------------------------------------------------------   
def retain2buffer4xi(task4retain2buffer=None):

    '''
    retains buffer4xi
    '''
    global buffer4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2buffer4xi"
    method2print = "retain2buffer4xi"

    message2print = "{(Step 1A/33) started" + "; retain2buffer4xi-started: " + str(retain2buffer4xi)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4retain2buffer-to-retain2buffer4xi: " + str(task4retain2buffer) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
 

             
    code2ack  = ' '
    code2nack = ' '

    if buffer4xi is None:
        buffer4xi = create2buffer4xi()                                                                            # CREATE BUFFER
                                
        message2print = "{(Step 1C/33) retain" + "; buffer4xi-retain-by-retain2buffer4xi to: " + str(buffer4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step A1/33) passing" + "; task-passing-to-retain2buffer4apu: " + str(task4retain2buffer['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['APU'] = retain2buffer4apu(task4retain2buffer['APU'])                                                      # 
         
        message2print = "{(Step A2/33) retain" + "; apu-context-retain-by-retain2buffer4apu to: " + str(buffer4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'AZ-'
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-retain2buffer4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step B1/33) passing" + "; task-passing-to-retain2buffer4bpu: " + str(task4retain2buffer['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['BPU'] = retain2buffer4bpu(task4retain2buffer['BPU'])                                                      # 
         
        message2print = "{(Step B2/33) retain" + "; bpu-context-retain-by-retain2buffer4bpu to: " + str(buffer4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'BZ-'
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-retain2buffer4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step C1/33) passing" + "; task-passing-to-retain2buffer4cpu: " + str(task4retain2buffer['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['CPU'] = retain2buffer4cpu(task4retain2buffer['CPU'])                                                      # 
         
        message2print = "{(Step C2/33) retain" + "; cpu-context-retain-by-retain2buffer4cpu to: " + str(buffer4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'CZ-'
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-retain2buffer4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step D1/33) passing" + "; task-passing-to-retain2buffer4dpu: " + str(task4retain2buffer['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['DPU'] = retain2buffer4dpu(task4retain2buffer['DPU'])                                                      # 
         
        message2print = "{(Step D2/33) retain" + "; dpu-context-retain-by-retain2buffer4dpu to: " + str(buffer4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'DZ-'
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-retain2buffer4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step E1/33) passing" + "; task-passing-to-retain2buffer4epu: " + str(task4retain2buffer['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['EPU'] = retain2buffer4epu(task4retain2buffer['EPU'])                                                      # 
         
        message2print = "{(Step E2/33) retain" + "; epu-context-retain-by-retain2buffer4epu to: " + str(buffer4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'EZ-'
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-retain2buffer4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step F1/33) passing" + "; task-passing-to-retain2buffer4fpu: " + str(task4retain2buffer['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['FPU'] = retain2buffer4fpu(task4retain2buffer['FPU'])                                                      # 
         
        message2print = "{(Step F2/33) retain" + "; fpu-context-retain-by-retain2buffer4fpu to: " + str(buffer4xi ['FPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'FZ-'
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-retain2buffer4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step G1/33) passing" + "; task-passing-to-retain2buffer4gpu: " + str(task4retain2buffer['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['GPU'] = retain2buffer4gpu(task4retain2buffer['GPU'])                                                      # 
         
        message2print = "{(Step G2/33) retain" + "; gpu-context-retain-by-retain2buffer4gpu to: " + str(buffer4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'GZ-'
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-retain2buffer4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step H1/33) passing" + "; task-passing-to-retain2buffer4hpu: " + str(task4retain2buffer['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['HPU'] = retain2buffer4hpu(task4retain2buffer['HPU'])                                                      # 
         
        message2print = "{(Step H2/33) retain" + "; hpu-context-retain-by-retain2buffer4hpu to: " + str(buffer4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'HZ-'
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-retain2buffer4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step I1/33) passing" + "; task-passing-to-retain2buffer4ipu: " + str(task4retain2buffer['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['IPU'] = retain2buffer4ipu(task4retain2buffer['IPU'])                                                      # 
         
        message2print = "{(Step I2/33) retain" + "; ipu-context-retain-by-retain2buffer4ipu to: " + str(buffer4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'IZ-'
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-retain2buffer4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step J1/33) passing" + "; task-passing-to-retain2buffer4jpu: " + str(task4retain2buffer['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['JPU'] = retain2buffer4jpu(task4retain2buffer['JPU'])                                                      # 
         
        message2print = "{(Step J2/33) retain" + "; jpu-context-retain-by-retain2buffer4jpu to: " + str(buffer4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'JZ-'
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-retain2buffer4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step K1/33) passing" + "; task-passing-to-retain2buffer4kpu: " + str(task4retain2buffer['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['KPU'] = retain2buffer4kpu(task4retain2buffer['KPU'])                                                      # 
         
        message2print = "{(Step K2/33) retain" + "; kpu-context-retain-by-retain2buffer4kpu to: " + str(buffer4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'KZ-'
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-retain2buffer4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step L1/33) passing" + "; task-passing-to-retain2buffer4lpu: " + str(task4retain2buffer['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['LPU'] = retain2buffer4lpu(task4retain2buffer['LPU'])                                                      # 
         
        message2print = "{(Step L2/33) retain" + "; lpu-context-retain-by-retain2buffer4lpu to: " + str(buffer4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'LZ-'
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-retain2buffer4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step M1/33) passing" + "; task-passing-to-retain2buffer4mpu: " + str(task4retain2buffer['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['MPU'] = retain2buffer4mpu(task4retain2buffer['MPU'])                                                      # 
         
        message2print = "{(Step M2/33) retain" + "; mpu-context-retain-by-retain2buffer4mpu to: " + str(buffer4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'MZ-'
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-retain2buffer4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step N1/33) passing" + "; task-passing-to-retain2buffer4npu: " + str(task4retain2buffer['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['NPU'] = retain2buffer4npu(task4retain2buffer['NPU'])                                                      # 
         
        message2print = "{(Step N2/33) retain" + "; npu-context-retain-by-retain2buffer4npu to: " + str(buffer4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'NZ-'
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-retain2buffer4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step O1/33) passing" + "; task-passing-to-retain2buffer4opu: " + str(task4retain2buffer['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['OPU'] = retain2buffer4opu(task4retain2buffer['OPU'])                                                      # 
         
        message2print = "{(Step O2/33) retain" + "; opu-context-retain-by-retain2buffer4opu to: " + str(buffer4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'OZ-'
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-retain2buffer4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step P1/33) passing" + "; task-passing-to-retain2buffer4ppu: " + str(task4retain2buffer['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['PPU'] = retain2buffer4ppu(task4retain2buffer['PPU'])                                                      # 
         
        message2print = "{(Step P2/33) retain" + "; ppu-context-retain-by-retain2buffer4ppu to: " + str(buffer4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'PZ-'
    except:
        message2print = "{(Step PZ1/33) yielded" + "; pu-yielded-by-retain2buffer4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Q1/33) passing" + "; task-passing-to-retain2buffer4qpu: " + str(task4retain2buffer['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['QPU'] = retain2buffer4qpu(task4retain2buffer['QPU'])                                                      # 
         
        message2print = "{(Step Q2/33) retain" + "; qpu-context-retain-by-retain2buffer4qpu to: " + str(buffer4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'QZ-'
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-retain2buffer4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step R1/33) passing" + "; task-passing-to-retain2buffer4rpu: " + str(task4retain2buffer['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['RPU'] = retain2buffer4rpu(task4retain2buffer['RPU'])                                                      # 
         
        message2print = "{(Step R2/33) retain" + "; rpu-context-retain-by-retain2buffer4rpu to: " + str(buffer4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'RZ-'
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-retain2buffer4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step S1/33) passing" + "; task-passing-to-retain2buffer4spu: " + str(task4retain2buffer['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['SPU'] = retain2buffer4spu(task4retain2buffer['SPU'])                                                      # 
         
        message2print = "{(Step S2/33) retain" + "; spu-context-retain-by-retain2buffer4spu to: " + str(buffer4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'SZ-'
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-retain2buffer4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step T1/33) passing" + "; task-passing-to-retain2buffer4tpu: " + str(task4retain2buffer['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['TPU'] = retain2buffer4tpu(task4retain2buffer['TPU'])                                                      # 
         
        message2print = "{(Step T2/33) retain" + "; tpu-context-retain-by-retain2buffer4tpu to: " + str(buffer4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'TZ-'
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-retain2buffer4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step U1/33) passing" + "; task-passing-to-retain2buffer4upu: " + str(task4retain2buffer['UPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['UPU'] = retain2buffer4upu(task4retain2buffer['UPU'])                                                      # 
         
        message2print = "{(Step U2/33) retain" + "; upu-context-retain-by-retain2buffer4upu to: " + str(buffer4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'UZ-'
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-retain2buffer4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step V1/33) passing" + "; task-passing-to-retain2buffer4vpu: " + str(task4retain2buffer['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['VPU'] = retain2buffer4vpu(task4retain2buffer['VPU'])                                                      # 
         
        message2print = "{(Step V2/33) retain" + "; vpu-context-retain-by-retain2buffer4vpu to: " + str(buffer4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'VZ-'
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-retain2buffer4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step W1/33) passing" + "; task-passing-to-retain2buffer4wpu: " + str(task4retain2buffer['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['WPU'] = retain2buffer4wpu(task4retain2buffer['WPU'])                                                      # 
         
        message2print = "{(Step W2/33) retain" + "; wpu-context-retain-by-retain2buffer4wpu to: " + str(buffer4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'WZ-'
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-retain2buffer4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step X1/33) passing" + "; task-passing-to-retain2buffer4xpu: " + str(task4retain2buffer['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['XPU'] = retain2buffer4xpu(task4retain2buffer['XPU'])                                                      # 
         
        message2print = "{(Step X2/33) retain" + "; xpu-context-retain-by-retain2buffer4xpu to: " + str(buffer4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'XZ-'
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-retain2buffer4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Y1/33) passing" + "; task-passing-to-retain2buffer4ypu: " + str(task4retain2buffer['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['YPU'] = retain2buffer4ypu(task4retain2buffer['YPU'])                                                      # 
         
        message2print = "{(Step Y2/33) retain" + "; ypu-context-retain-by-retain2buffer4ypu to: " + str(buffer4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'YZ-'
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-retain2buffer4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Z1/33) passing" + "; task-passing-to-retain2buffer4zpu: " + str(task4retain2buffer['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['ZPU'] = retain2buffer4zpu(task4retain2buffer['ZPU'])                                                      # 
         
        message2print = "{(Step Z2/33) retain" + "; zpu-context-retain-by-retain2buffer4zpu to: " + str(buffer4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'ZZ-'
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-retain2buffer4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------

    
    message2print = "{(Step 33/33) returning" + "; buffer4xi-returning-by-retain2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    return buffer4xi

#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2buffer4xi" usage = "
#
# Example 1:
#     print('(Step 4A/33) OF BUFFER5TEST - TRYING TO RELEASE BUFFER4XI ', time4xi())
#     try:                               
#         response4release2buffer = release2buffer4xi()                                                       
#         print('(Step 4B/33) OF BUFFER5TEST - RESPONSE4SET2CONTEXT : ', response4release2buffer) 
#     except:
#         print('(Step 4Z1/33) OF BUFFER5TEST *** FAILED TO RELEASE BUFFER4XI ', time4xi())                  
#                            
#">

# -------------------------------------------------------------------------------------------------   
def release2buffer4xi(task4release2buffer=None):

    '''
    releases buffer4xi
    '''
    global buffer4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2buffer4xi"
    method2print = "release2buffer4xi"

    message2print = "{(Step 1A/33) started" + "; release2buffer4xi-started: " + str(release2buffer4xi)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4release2buffer-to-release2buffer4xi: " + str(task4release2buffer) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 

             
    code2ack  = ' '
    code2nack = ' '

    if buffer4xi is None:
        buffer4xi = create2buffer4xi()                                                                            # CREATE BUFFER
                                
        message2print = "{(Step 1C/33) release" + "; buffer4xi-release-by-release2buffer4xi to: " + str(buffer4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
        


    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step A1/33) passing" + "; task-passing-to-release2buffer4apu: " + str(task4release2buffer['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['APU'] = release2buffer4apu(task4release2buffer['APU'])                                                      # 
         
        message2print = "{(Step A2/33) release" + "; apu-context-release-by-release2buffer4apu to: " + str(buffer4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'A2-'
    except:
        message2print = "{(Step AZ/33) yielded" + "; apu-yielded-by-release2buffer4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step B1/33) passing" + "; task-passing-to-release2buffer4bpu: " + str(task4release2buffer['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['BPU'] = release2buffer4bpu(task4release2buffer['BPU'])                                                      # 
         
        message2print = "{(Step B2/33) release" + "; bpu-context-release-by-release2buffer4bpu to: " + str(buffer4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'B2-'
    except:
        message2print = "{(Step BZ/33) yielded" + "; bpu-yielded-by-release2buffer4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step C1/33) passing" + "; task-passing-to-release2buffer4cpu: " + str(task4release2buffer['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['CPU'] = release2buffer4cpu(task4release2buffer['CPU'])                                                      # 
         
        message2print = "{(Step C2/33) release" + "; cpu-context-release-by-release2buffer4cpu to: " + str(buffer4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'C2-'
    except:
        message2print = "{(Step CZ/33) yielded" + "; cpu-yielded-by-release2buffer4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step D1/33) passing" + "; task-passing-to-release2buffer4dpu: " + str(task4release2buffer['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['DPU'] = release2buffer4dpu(task4release2buffer['DPU'])                                                      # 
         
        message2print = "{(Step D2/33) release" + "; dpu-context-release-by-release2buffer4dpu to: " + str(buffer4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'D2-'
    except:
        message2print = "{(Step DZ/33) yielded" + "; dpu-yielded-by-release2buffer4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step E1/33) passing" + "; task-passing-to-release2buffer4epu: " + str(task4release2buffer['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['EPU'] = release2buffer4epu(task4release2buffer['EPU'])                                                      # 
         
        message2print = "{(Step E2/33) release" + "; epu-context-release-by-release2buffer4epu to: " + str(buffer4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'E2-'
    except:
        message2print = "{(Step EZ/33) yielded" + "; epu-yielded-by-release2buffer4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step F1/33) passing" + "; task-passing-to-release2buffer4fpu: " + str(task4release2buffer['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['FPU'] = release2buffer4fpu(task4release2buffer['FPU'])                                                      # 
         
        message2print = "{(Step F2/33) release" + "; fpu-context-release-by-release2buffer4fpu to: " + str(buffer4xi ['FPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'F2-'
    except:
        message2print = "{(Step FZ/33) yielded" + "; fpu-yielded-by-release2buffer4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step G1/33) passing" + "; task-passing-to-release2buffer4gpu: " + str(task4release2buffer['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['GPU'] = release2buffer4gpu(task4release2buffer['GPU'])                                                      # 
         
        message2print = "{(Step G2/33) release" + "; gpu-context-release-by-release2buffer4gpu to: " + str(buffer4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'G2-'
    except:
        message2print = "{(Step GZ/33) yielded" + "; gpu-yielded-by-release2buffer4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step H1/33) passing" + "; task-passing-to-release2buffer4hpu: " + str(task4release2buffer['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['HPU'] = release2buffer4hpu(task4release2buffer['HPU'])                                                      # 
         
        message2print = "{(Step H2/33) release" + "; hpu-context-release-by-release2buffer4hpu to: " + str(buffer4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'H2-'
    except:
        message2print = "{(Step HZ/33) yielded" + "; hpu-yielded-by-release2buffer4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step I1/33) passing" + "; task-passing-to-release2buffer4ipu: " + str(task4release2buffer['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['IPU'] = release2buffer4ipu(task4release2buffer['IPU'])                                                      # 
         
        message2print = "{(Step I2/33) release" + "; ipu-context-release-by-release2buffer4ipu to: " + str(buffer4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'I2-'
    except:
        message2print = "{(Step IZ/33) yielded" + "; ipu-yielded-by-release2buffer4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step J1/33) passing" + "; task-passing-to-release2buffer4jpu: " + str(task4release2buffer['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['JPU'] = release2buffer4jpu(task4release2buffer['JPU'])                                                      # 
         
        message2print = "{(Step J2/33) release" + "; jpu-context-release-by-release2buffer4jpu to: " + str(buffer4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'J2-'
    except:
        message2print = "{(Step JZ/33) yielded" + "; jpu-yielded-by-release2buffer4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step K1/33) passing" + "; task-passing-to-release2buffer4kpu: " + str(task4release2buffer['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['KPU'] = release2buffer4kpu(task4release2buffer['KPU'])                                                      # 
         
        message2print = "{(Step K2/33) release" + "; kpu-context-release-by-release2buffer4kpu to: " + str(buffer4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'K2-'
    except:
        message2print = "{(Step KZ/33) yielded" + "; kpu-yielded-by-release2buffer4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step L1/33) passing" + "; task-passing-to-release2buffer4lpu: " + str(task4release2buffer['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['LPU'] = release2buffer4lpu(task4release2buffer['LPU'])                                                      # 
         
        message2print = "{(Step L2/33) release" + "; lpu-context-release-by-release2buffer4lpu to: " + str(buffer4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'L2-'
    except:
        message2print = "{(Step LZ/33) yielded" + "; lpu-yielded-by-release2buffer4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step M1/33) passing" + "; task-passing-to-release2buffer4mpu: " + str(task4release2buffer['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['MPU'] = release2buffer4mpu(task4release2buffer['MPU'])                                                      # 
         
        message2print = "{(Step M2/33) release" + "; mpu-context-release-by-release2buffer4mpu to: " + str(buffer4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'M2-'
    except:
        message2print = "{(Step MZ/33) yielded" + "; mpu-yielded-by-release2buffer4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step N1/33) passing" + "; task-passing-to-release2buffer4npu: " + str(task4release2buffer['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['NPU'] = release2buffer4npu(task4release2buffer['NPU'])                                                      # 
         
        message2print = "{(Step N2/33) release" + "; npu-context-release-by-release2buffer4npu to: " + str(buffer4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'N2-'
    except:
        message2print = "{(Step NZ/33) yielded" + "; npu-yielded-by-release2buffer4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step O1/33) passing" + "; task-passing-to-release2buffer4opu: " + str(task4release2buffer['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['OPU'] = release2buffer4opu(task4release2buffer['OPU'])                                                      # 
         
        message2print = "{(Step O2/33) release" + "; opu-context-release-by-release2buffer4opu to: " + str(buffer4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'O2-'
    except:
        message2print = "{(Step OZ/33) yielded" + "; opu-yielded-by-release2buffer4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step P1/33) passing" + "; task-passing-to-release2buffer4ppu: " + str(task4release2buffer['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['PPU'] = release2buffer4ppu(task4release2buffer['PPU'])                                                      # 
         
        message2print = "{(Step P2/33) release" + "; ppu-context-release-by-release2buffer4ppu to: " + str(buffer4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'P2-'
    except:
        message2print = "{(Step PZ/33) yielded" + "; ppu-yielded-by-release2buffer4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Q1/33) passing" + "; task-passing-to-release2buffer4qpu: " + str(task4release2buffer['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['QPU'] = release2buffer4qpu(task4release2buffer['QPU'])                                                      # 
         
        message2print = "{(Step Q2/33) release" + "; qpu-context-release-by-release2buffer4qpu to: " + str(buffer4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'Q2-'
    except:
        message2print = "{(Step QZ/33) yielded" + "; qpu-yielded-by-release2buffer4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step R1/33) passing" + "; task-passing-to-release2buffer4rpu: " + str(task4release2buffer['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['RPU'] = release2buffer4rpu(task4release2buffer['RPU'])                                                      # 
         
        message2print = "{(Step R2/33) release" + "; rpu-context-release-by-release2buffer4rpu to: " + str(buffer4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'R2-'
    except:
        message2print = "{(Step RZ/33) yielded" + "; rpu-yielded-by-release2buffer4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step S1/33) passing" + "; task-passing-to-release2buffer4spu: " + str(task4release2buffer['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['SPU'] = release2buffer4spu(task4release2buffer['SPU'])                                                      # 
         
        message2print = "{(Step S2/33) release" + "; spu-context-release-by-release2buffer4spu to: " + str(buffer4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'S2-'
    except:
        message2print = "{(Step SZ/33) yielded" + "; spu-yielded-by-release2buffer4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step T1/33) passing" + "; task-passing-to-release2buffer4tpu: " + str(task4release2buffer['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['TPU'] = release2buffer4tpu(task4release2buffer['TPU'])                                                      # 
         
        message2print = "{(Step T2/33) release" + "; tpu-context-release-by-release2buffer4tpu to: " + str(buffer4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'T2-'
    except:
        message2print = "{(Step TZ/33) yielded" + "; tpu-yielded-by-release2buffer4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step U1/33) passing" + "; task-passing-to-release2buffer4upu: " + str(task4release2buffer['UPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['UPU'] = release2buffer4upu(task4release2buffer['UPU'])                                                      # 
         
        message2print = "{(Step U2/33) release" + "; upu-context-release-by-release2buffer4upu to: " + str(buffer4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'U2-'
    except:
        message2print = "{(Step UZ/33) yielded" + "; upu-yielded-by-release2buffer4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step V1/33) passing" + "; task-passing-to-release2buffer4vpu: " + str(task4release2buffer['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['VPU'] = release2buffer4vpu(task4release2buffer['VPU'])                                                      # 
         
        message2print = "{(Step V2/33) release" + "; vpu-context-release-by-release2buffer4vpu to: " + str(buffer4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'V2-'
    except:
        message2print = "{(Step VZ/33) yielded" + "; vpu-yielded-by-release2buffer4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step W1/33) passing" + "; task-passing-to-release2buffer4wpu: " + str(task4release2buffer['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['WPU'] = release2buffer4wpu(task4release2buffer['WPU'])                                                      # 
         
        message2print = "{(Step W2/33) release" + "; wpu-context-release-by-release2buffer4wpu to: " + str(buffer4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'W2-'
    except:
        message2print = "{(Step WZ/33) yielded" + "; wpu-yielded-by-release2buffer4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step X1/33) passing" + "; task-passing-to-release2buffer4xpu: " + str(task4release2buffer['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['XPU'] = release2buffer4xpu(task4release2buffer['XPU'])                                                      # 
         
        message2print = "{(Step X2/33) release" + "; xpu-context-release-by-release2buffer4xpu to: " + str(buffer4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'X2-'
    except:
        message2print = "{(Step XZ/33) yielded" + "; xpu-yielded-by-release2buffer4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Y1/33) passing" + "; task-passing-to-release2buffer4ypu: " + str(task4release2buffer['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['YPU'] = release2buffer4ypu(task4release2buffer['YPU'])                                                      # 
         
        message2print = "{(Step Y2/33) release" + "; ypu-context-release-by-release2buffer4ypu to: " + str(buffer4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'Y2-'
    except:
        message2print = "{(Step YZ/33) yielded" + "; ypu-yielded-by-release2buffer4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Z1/33) passing" + "; task-passing-to-release2buffer4zpu: " + str(task4release2buffer['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        buffer4xi ['PU'] = release2buffer4zpu(task4release2buffer['ZPU'])                                                      # 
         
        message2print = "{(Step Z2/33) release" + "; zpu-context-release-by-release2buffer4zpu to: " + str(buffer4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'Z2-'
    except:
        message2print = "{(Step ZZ/33) yielded" + "; zpu-yielded-by-release2buffer4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------

    
    message2print = "{(Step 33/33) returning" + "; buffer4xi-returning-by-release2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    return buffer4xi

            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2bufferinfo4xi" usage = "
#
#    try:                               
#        response4get2bufferinfo = get2bufferinfo4xi()                                        
#                                                                                                                   
#    except:
#        ... 
#                          
#">

# -------------------------------------------------------------------------------------------------   
def get2bufferinfo4xi():

    '''
    gets buffer4xi
    '''
    
    global buffer4xi
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2bufferinfo4xi"
    method2print = "get2bufferinfo4xi"

    message2print = "{(Step 1A/33) started" + "; get2bufferinfo-started: " + str(get2bufferinfo4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                               
    # <function get2bufferinfo4xi at 0x00000000043065C8> 
    
    cc2xi = None
    try: 
        if buffer4xi is None:
            # -------------------------------------------------------------------------------------
            # TRY TO CREATE           
            # -------------------------------------------------------------------------------------           
            cc2xi = create2buffer4xi()
            
            message2print = "{(Step 1B/33) initialized" + "; cc2xi-initialized-by-get2bufferinfo to: " + str(cc2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  
        else:
            # -------------------------------------------------------------------------------------
            # USE           
            # -------------------------------------------------------------------------------------         
            cc2xi = {} 
            
            cc2xi['APU'] = get2bufferinfo4apu()
            message2print = "{(Step 1C1/33) got" + "; apubuffer-got-by-get2bufferinfo: " + str(cc2xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'CODE2ERROR': 0,
            #  'COUNT2REFERENCE': 0,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4apu-failed ; time: 03:47:23 09/02/11 Pacific Daylight Time}',
            #  'CLASS': 'create2buffer4apu',
            #  'METHOD': 'create2buffer4apu'},
            #  'FUNCTION2CALLBACK': <function trace2buffer4apu at 0x00000000040512C8>,
            #  'POINTER2BUFFER': <mmap.mmap object at 0x00000000044A5088>,
            #  'FLAGS': 0,
            #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4apu-failed ; time: 03:47:23 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4apu', 'METHOD': 'create2context4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x0000000003327B48>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_APU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}; time: 03:47:24 09/02/11 Pacific Daylight Time}

            cc2xi['BPU'] = get2bufferinfo4bpu()
            message2print = "{(Step 1C1/33) got" + "; bpubuffer-got-by-get2bufferinfo: " + str(cc2xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'CODE2ERROR': 0,
            #  'COUNT2REFERENCE': 0,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4bpu-failed ; time: 03:47:23 09/02/11 Pacific Daylight Time}',
            #  'CLASS': 'create2buffer4bpu',
            #  'METHOD': 'create2buffer4bpu'},
            #  'FUNCTION2CALLBACK': <function trace2buffer4bpu at 0x0000000003F6E348>,
            #  'POINTER2BUFFER': <mmap.mmap object at 0x00000000044A5818>,
            #  'FLAGS': 0,
            #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4bpu-failed ; time: 03:47:23 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4bpu', 'METHOD': 'create2context4bpu'}, 'FUNCTION2CALLBACK': <function trace2context4bpu at 0x000000000405BBC8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_BPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}; time: 03:47:24 09/02/11 Pacific Daylight Time}

            cc2xi['CPU'] = get2bufferinfo4cpu()
            message2print = "{(Step 1C1/33) got" + "; cpubuffer-got-by-get2bufferinfo: " + str(cc2xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'CODE2ERROR': 0,
            #  'COUNT2REFERENCE': 0,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4cpu-failed ; time: 03:47:23 09/02/11 Pacific Daylight Time}',
            #  'CLASS': 'create2buffer4cpu',
            #  'METHOD': 'create2buffer4cpu'},
            #  'FUNCTION2CALLBACK': <function trace2buffer4cpu at 0x0000000003D7A3C8>,
            #  'POINTER2BUFFER': <mmap.mmap object at 0x00000000044A58C8>,
            #  'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4cpu-failed ; time: 03:47:23 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4cpu', 'METHOD': 'create2context4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x0000000003F79C48>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4017, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_CPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}; time: 03:47:24 09/02/11 Pacific Daylight Time}
             
            cc2xi['DPU'] = get2bufferinfo4dpu()
            message2print = "{(Step 1C1/33) got" + "; dpubuffer-got-by-get2bufferinfo: " + str(cc2xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['EPU'] = get2bufferinfo4epu()
            message2print = "{(Step 1C1/33) got" + "; epubuffer-got-by-get2bufferinfo: " + str(cc2xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['FPU'] = get2bufferinfo4fpu()
            message2print = "{(Step 1C1/33) got" + "; fpubuffer-got-by-get2bufferinfo: " + str(cc2xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['GPU'] = get2bufferinfo4gpu()
            message2print = "{(Step 1C1/33) got" + "; gpubuffer-got-by-get2bufferinfo: " + str(cc2xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['HPU'] = get2bufferinfo4hpu()
            message2print = "{(Step 1C1/33) got" + "; hpubuffer-got-by-get2bufferinfo: " + str(cc2xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['IPU'] = get2bufferinfo4ipu()
            message2print = "{(Step 1C1/33) got" + "; ipubuffer-got-by-get2bufferinfo: " + str(cc2xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['JPU'] = get2bufferinfo4jpu()
            message2print = "{(Step 1C1/33) got" + "; jpubuffer-got-by-get2bufferinfo: " + str(cc2xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['KPU'] = get2bufferinfo4kpu()
            message2print = "{(Step 1C1/33) got" + "; kpubuffer-got-by-get2bufferinfo: " + str(cc2xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['LPU'] = get2bufferinfo4lpu()
            message2print = "{(Step 1C1/33) got" + "; lpubuffer-got-by-get2bufferinfo: " + str(cc2xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['MPU'] = get2bufferinfo4mpu()
            message2print = "{(Step 1C1/33) got" + "; mpubuffer-got-by-get2bufferinfo: " + str(cc2xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['NPU'] = get2bufferinfo4npu()
            message2print = "{(Step 1C1/33) got" + "; npubuffer-got-by-get2bufferinfo: " + str(cc2xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #            
            cc2xi['OPU'] = get2bufferinfo4opu()
            message2print = "{(Step 1C1/33) got" + "; opubuffer-got-by-get2bufferinfo: " + str(cc2xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['PPU'] = get2bufferinfo4ppu()
            message2print = "{(Step 1C1/33) got" + "; ppubuffer-got-by-get2bufferinfo: " + str(cc2xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['QPU'] = get2bufferinfo4qpu()
            message2print = "{(Step 1C1/33) got" + "; qpubuffer-got-by-get2bufferinfo: " + str(cc2xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['RPU'] = get2bufferinfo4rpu()
            message2print = "{(Step 1C1/33) got" + "; rpubuffer-got-by-get2bufferinfo: " + str(cc2xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['SPU'] = get2bufferinfo4spu()
            message2print = "{(Step 1C1/33) got" + "; spubuffer-got-by-get2bufferinfo: " + str(cc2xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['TPU'] = get2bufferinfo4tpu()
            message2print = "{(Step 1C1/33) got" + "; tpubuffer-got-by-get2bufferinfo: " + str(cc2xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['UPU'] = get2bufferinfo4upu()
            message2print = "{(Step 1C1/33) got" + "; upubuffer-got-by-get2bufferinfo: " + str(cc2xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #            
            cc2xi['VPU'] = get2bufferinfo4vpu()
            message2print = "{(Step 1C1/33) got" + "; vpubuffer-got-by-get2bufferinfo: " + str(cc2xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['WPU'] = get2bufferinfo4wpu()
            message2print = "{(Step 1C1/33) got" + "; wpubuffer-got-by-get2bufferinfo: " + str(cc2xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['XPU'] = get2bufferinfo4xpu()
            message2print = "{(Step 1C1/33) got" + "; xpubuffer-got-by-get2bufferinfo: " + str(cc2xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['YPU'] = get2bufferinfo4ypu()
            message2print = "{(Step 1C1/33) got" + "; ypubuffer-got-by-get2bufferinfo: " + str(cc2xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
            cc2xi['ZPU'] = get2bufferinfo4zpu()
            message2print = "{(Step 1C1/33) got" + "; zpubuffer-got-by-get2bufferinfo: " + str(cc2xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4zpu-failed ; time: 03:47:24 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4zpu', 'METHOD': 'create2buffer4zpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4zpu at 0x0000000004429F48>, 'POINTER2BUFFER': <mmap.mmap object at 0x0000000004A10088>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4zpu-failed ; time: 03:47:24 09/02/11 Pacific Daylight Time}', 'CLASS': 'create2context4zpu', 'METHOD': 'create2context4zpu'}, 'FUNCTION2CALLBACK': <function trace2context4zpu at 0x0000000004411848>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_ZPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}; time: 03:47:24 09/02/11 Pacific Daylight Time}
           

            
    except:
        try:
            # -------------------------------------------------------------------------------------
            # TRY TO CREATE           
            # -------------------------------------------------------------------------------------           
            cc2xi = create2buffer4xi()
            
            message2print = "{(Step 1D/33) initialized" + "; cc2xi-initialized-by-get2bufferinfo to: " + str(cc2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #              
       
        except:
            # -------------------------------------------------------------------------------------
            # YIELD!        
            # -------------------------------------------------------------------------------------                      
            cc2xi = {}
            
            message2print = "{(Step 1Z/33) yielded" + "; cc2xi-yielded-by-get2bufferinfo: " + str(cc2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            
            
    message2print = "{(Step 33/33) returning" + "; cc2xi-returning-by-get2bufferinfo: " + str(cc2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # {'DPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': ...
    
    return cc2xi
            
#</function4xi> 
 
                                               
# =================================================================================================
#<class4xi class = "Buffer4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for Buffer" usage = "OpenCL Buffer"
#>

# =================================================================================================
class Buffer4Xi(object): 
    ''' 
    Buffer4Xi offers  methods for Buffer
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2buffer = None
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
    'create2buffer',
    'create2subbuffer',
    'get2bufferinfo',
    'release2buffer',
    'retain2buffer',
    'set2buffer',
    'sense',
    'reason',
    'ace')          
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create-of-Buffer4Xi" usage = "initializes Buffer4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4create2buffer = None):
        '''
        _init__ method initializes Buffer4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "Buffer4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; create-of-Buffer4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 03:47:24 09/02/11 Pacific Daylight Time 

        message2print = "{(Step 1B/33) borning" + "; cc2xi-of-Buffer4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-cc2xi-of-Buffer4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2buffer-sharing-by-cc2xi-of-Buffer4Xi: " + str(Buffer4Xi.classvariable2buffer)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #              
                                
        message2print = "{(Step 1E/33) passed" + "; task4create2buffer-passed-to-create-of-Buffer4Xi: " + str(task4create2buffer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #                              
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) passing" + "; task4create2buffer-passing-to-create2buffer4xi-by-create-of-Buffer4Xi: " + str(task4create2buffer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        cc2xi = create2buffer4xi(task4create2buffer)
        
        message2print = "{(Step 2B/33) performed" + "; create2buffer4xi-performed-by-create-of-Buffer4Xi: " + str(create2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #    
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; cc2xi-of-Buffer4Xi-activated " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-cc2xi-of-Buffer4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2buffer-shared-by-cc2xi-of-Buffer4Xi: " + str(Buffer4Xi.classvariable2buffer)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #            
       
        message2print = "{(Step 3D/33) returning" + "; create-of-Buffer4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 03:47:24 09/02/11 Pacific Daylight Time 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2buffer-of-Buffer4Xi" usage = "initializes objects of Buffer4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def create2buffer(self, task4create2buffer = None):
        '''
        create2buffer method creates buffer for Buffer4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)            
        # -----------------------------------------------------------------------------------------              
        class2print = "Buffer4Xi"
        method2print = "create2buffer"
                      
        message2print = "{(Step 1A/33) started" + "; create2buffer-of-Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4create2buffer-passed-to-create2buffer-of-Buffer4Xi: " + str(task4create2buffer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
                                  
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4create2buffer-passing-to-create2buffer4xi-by-create-of-Buffer4Xi: " + str(task4create2buffer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
  
        cc2xi = create2buffer4xi(task4create2buffer)

        message2print = "{(Step 2B/33) performed" + "; create2buffer4xi-performed-by-create2buffer-of-Buffer4Xi: " + str(create2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; cc2xi-returning-by-create2buffer-of-Buffer4Xi: " + str(cc2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # {'DPU': {'POINTER2BUFFER': <mmap.mmap object at 0x0000000004A10450> ...
        
        return cc2xi
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2subbuffer-of-Buffer4Xi" usage = "initializes objects of Buffer4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def create2subbuffer(self, task4create2subbuffer = None):
        '''
        create2subbuffer method creates subbuffer for Buffer4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)            
        # -----------------------------------------------------------------------------------------              
        class2print = "Buffer4Xi"
        method2print = "create2subbuffer"
                      
        message2print = "{(Step 1A/33) started" + "; create2subbuffer-of-Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 06:18:33 05/24/11 Pacific Daylight Time
            
        message2print = "{(Step 1B/33) passed" + "; task4create2subbuffer-passed-to-create2subbuffer: " + str(task4create2subbuffer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
                                  
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4create2subbuffer-passing-to-create2subbuffer4xi-by-create2subbuffer-of-Buffer4Xi: " + str(task4create2subbuffer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
  
        cc2xi = create2subbuffer4xi(task4create2subbuffer)

        message2print = "{(Step 2B/33) performed" + "; create2subbuffer4xi-performed-by-create2subbuffer-of-Buffer4Xi: " + str(create2subbuffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2subbuffer4xi at 0x0000000003B34948> 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; cc2xi-returning-by-create2subbuffer-of-Buffer4Xi: " + str(cc2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #  
        
        return cc2xi
                                
                            
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2buffer-of-Buffer4Xi" usage = "sets objects of Buffer4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def set2buffer(self, task4set2buffer = None):
        '''
        set2buffer method sets objects of Buffer4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Buffer4Xi"
        method2print = "set2buffer"
                     
        message2print = "{(Step 1A/33) started" + "; set2buffer-of-Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2buffer-passed-to-set2buffer-of-Buffer4Xi: " + str(task4set2buffer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #                                                           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2buffer-passing-to-set2buffer4xi-by-set2buffer-of-Buffer4Xi: " + str(task4set2buffer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #   
                
  
        cc2xi = set2buffer4xi(task4set2buffer)

        message2print = "{(Step 2B/33) performed" + "; set2buffer4xi-performed-by-set2buffer-of-Buffer4Xi: " + str(set2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; cc2xi-returning-by-set2buffer-of-Buffer4Xi: " + str(cc2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        return cc2xi

    #</methodize4xi>
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2buffer-of-Buffer4Xi" usage = "releases objects of Buffer4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def release2buffer(self, task4release2buffer = None):
        '''
        release2buffer method releases objects of Buffer4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Buffer4Xi"
        method2print = "release2buffer"
                     
        message2print = "{(Step 1A/33) started" + "; release2buffer-of-Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4release2buffer-passed-to-release2buffer-of-Buffer4Xi: " + str(task4release2buffer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #                                                          
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2buffer-passing-to-release2buffer4xi-by-release2buffer-of-Buffer4Xi: " + str(task4release2buffer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #    
                
  
        cc2xi = release2buffer4xi(task4release2buffer)

        message2print = "{(Step 2B/33) performed" + "; release2buffer4xi-performed-by-release2buffer-of-Buffer4Xi: " + str(release2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; cc2xi-returning-by-release2buffer-of-Buffer4Xi: " + str(cc2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        
        return cc2xi                                
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2buffer-of-Buffer4Xi" usage = "retains objects of Buffer4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2buffer(self, task4retain2buffer = None):
        '''
        retain2buffer method retains objects of Buffer4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Buffer4Xi"
        method2print = "retain2buffer"
                     
        message2print = "{(Step 1A/33) started" + "; retain2buffer-of-Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4retain2buffer-passed-to-retain2buffer-of-Buffer4Xi: " + str(task4retain2buffer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #                                                           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain2buffer-passing-to-retain2buffer4xi-by-retain2buffer-of-Buffer4Xi: " + str(task4retain2buffer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #   
                
  
        cc2xi = retain2buffer4xi(task4retain2buffer)

        message2print = "{(Step 2B/33) performed" + "; retain2buffer4xi-performed-by-retain2buffer-of-Buffer4Xi: " + str(retain2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; cc2xi-returning-by-retain2buffer-of-Buffer4Xi: " + str(cc2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
                
        return cc2xi                                
        
                                    
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2bufferinfo-of-Buffer4Xi" usage = "gets objects of Buffer4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def get2bufferinfo(self):
        '''
        get2bufferinfo method gets objects of Buffer4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Buffer4Xi"
        method2print = "get2bufferinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2bufferinfo-of-Buffer4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        # 
            

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        cc2xi = get2bufferinfo4xi()
        
        message2print = "{(Step 2A/33) returning" + "; cc2xi-returning-by-get2bufferinfo-of-Buffer4Xi: " + str(cc2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        # 
        
        return cc2xi
                                
                            
    #</methodize4xi>                                     
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Buffer4Xi" usage = "senses Buffer4Xi class objects">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses Buffer4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Buffer4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; Buffer4Xi-sensing-by-sense-of-Buffer4Xi: " + str(Buffer4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #         
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-Buffer4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2buffer-of-Buffer4Xi'] = Buffer4Xi.classvariable2buffer
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-Buffer4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; Buffer4Xi-sensed-by-sense-of-Buffer4Xi: " + str(Buffer4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-Buffer4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        # {'object': <buffer4xi.Buffer4Xi object at 0x0000000003E21C18>, 'classvariable2buffer-of-Buffer4Xi': None}; time: 06:04:05 05/21/11 Pacific Daylight Time}
        
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Buffer4Xi" usage = "reasons Buffer4Xi class objects">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons Buffer4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Buffer4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; Buffer4Xi-reasoning-by-reason-of-Buffer4Xi: " + str(Buffer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-Buffer4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-Buffer4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-Buffer4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; Buffer4Xi-reasoned-by-reason-of-Buffer4Xi: " + str(Buffer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-Buffer4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                         
        # {'object-reason-object4xi': <buffer4xi.Buffer4Xi object at 0x0000000003E21C18>, 'time-reason-of-Buffer4Xi': '06:04:05 05/21/11 Pacific Daylight Time'}; time: 06:04:05 05/21/11 Pacific Daylight Time}

          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Buffer4Xi" usage = "aces Buffer4Xi class objects">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces Buffer4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'Buffer4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; Buffer4Xi-acing-by-ace-of-Buffer4Xi: " + str(Buffer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #  
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-Buffer4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['time-ace-of-Buffer4Xi'] = time4xi()
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-Buffer4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; Buffer4Xi-aced-by-ace-of-Buffer4Xi: " + str(Buffer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-Buffer4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        #                        
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   get2bufferinfo4xi5test.txt
#   sense-test-get2bufferinfo4xi.xml
#   reason-test-get2bufferinfo4xi.xml
#   ace-test-get2bufferinfo4xi.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# None
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of buffer4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
